﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Threading.Tasks;
using Cascading_ListBox_MVC_Core.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Cascading_ListBox_MVC_Core.Controllers
{
    public class HomeController : Controller
    {
        private DBCtx Context { get; }
        public HomeController(DBCtx _context)
        {
            this.Context = _context;
        }

        public IActionResult Index()
        {
            CascadingModel model = new CascadingModel();
            model.Countries = (from country in this.Context.Countries
                               select new SelectListItem
                               {
                                   Value = country.CountryId.ToString(),
                                   Text = country.CountryName
                               }).ToList();
            return View(model);
        }

        [HttpPost]
        public ActionResult Index(int? countryId, int? stateId, int? cityId)
        {
            CascadingModel model = new CascadingModel();
            model.Countries = (from country in this.Context.Countries
                               select new SelectListItem
                               {
                                   Value = country.CountryId.ToString(),
                                   Text = country.CountryName
                               }).ToList();

            if (countryId.HasValue)
            {
                model.States = (from state in this.Context.States
                                where state.CountryId == countryId
                                select new SelectListItem
                                {
                                    Value = state.StateId.ToString(),
                                    Text = state.StateName
                                }).ToList();
            }

            if (stateId.HasValue)
            {
                model.Cities = (from city in this.Context.Cities
                                where city.StateId == stateId
                                select new SelectListItem
                                {
                                    Value = city.CityId.ToString(),
                                    Text = city.CityName
                                }).ToList();
            }

            return View(model);
        }
    }
}